Index: s390-tools-sles11/include/vtoc.h
===================================================================
--- s390-tools-sles11.orig/include/vtoc.h
+++ s390-tools-sles11/include/vtoc.h
@@ -42,9 +42,17 @@
 
 #define VOLSER_LENGTH 6
 #define BIG_DISK_SIZE 0x10000
+#define LV_COMPAT_CYL 0xFFFE
 
 #define VTOC_ERROR "VTOC error:"
 
+/* definition from hdreq.h */
+struct hd_geometry {
+      unsigned char heads;
+      unsigned char sectors;
+      unsigned short cylinders;
+      unsigned long start;
+};
 
 typedef struct ttr 
 {
@@ -71,8 +79,19 @@ typedef struct labeldate 
         u_int16_t day;
 } __attribute__ ((packed)) labeldate_t;
 
-
-typedef struct volume_label 
+/*
+ * The following structure is a merger of the cdl and ldl volume label.
+ * On an ldl disk there is no key information, so when reading an
+ * ldl label from disk, the data should be copied at the address of vollbl.
+ * On the other side, the field ldl_version is reserved in a cdl record
+ * and the field formatted_cyl exists only for ldl labels. So when
+ * reading a cdl label from disk, the formatted_cyl field will contain
+ * arbitrary data.
+ * This layout may be a bit awkward, but the advantage of having the
+ * same label type for both disk layout types is bigger than the effort
+ * for taking a bit of extra care at the fringes.
+ */
+typedef struct volume_label
 {
         char volkey[4];         /* volume key = volume label                 */
 	char vollbl[4];	        /* volume label                              */
@@ -86,10 +105,11 @@ typedef struct volume_label 
 	char labperci[4];       /* no of labels per CI (FBA), blanks for CKD */
 	char res2[4];	        /* reserved                                  */
 	char lvtoc[14];	        /* owner code for LVTOC                      */
-	char res3[29];	        /* reserved                                  */
+	char res3[28];	        /* reserved                                  */
+ 	char ldl_version;	/* version number, valid for ldl format      */
+ 	unsigned long long formatted_blocks; /* valid when ldl_version >= f2 */
 } __attribute__ ((packed)) volume_label_t;
 
-
 typedef struct extent 
 {
         u_int8_t  typeind;          /* extent type indicator                     */
@@ -113,8 +133,11 @@ typedef struct dev_const 
         u_int8_t  DS4DEVDB;           /* number of directory blocks per track    */
 } __attribute__ ((packed)) dev_const_t;
 
-
-typedef struct format1_label 
+/*
+ * format 1 and format 8 label have the same layout so we use the following
+ * structure for both.
+ */
+typedef struct format1_label
 {
 	char  DS1DSNAM[44];       /* data set name                           */
 	u_int8_t  DS1FMTID;       /* format identifier                       */
@@ -123,27 +146,27 @@ typedef struct format1_label 
 	labeldate_t DS1CREDT;     /* creation date: ydd                      */
 	labeldate_t DS1EXPDT;     /* expiration date                         */
 	u_int8_t  DS1NOEPV;           /* number of extents on volume             */
-        u_int8_t  DS1NOBDB;           /* no. of bytes used in last direction blk */
+	u_int8_t  DS1NOBDB;           /* no. of bytes used in last direction blk */
 	u_int8_t  DS1FLAG1;           /* flag 1                                  */
 	unsigned char  DS1SYSCD[13];  /* system code                         */
 	labeldate_t DS1REFD;      /* date last referenced                    */
-        u_int8_t  DS1SMSFG;           /* system managed storage indicators       */
-        u_int8_t  DS1SCXTF;           /* sec. space extension flag byte          */
-        u_int16_t DS1SCXTV;           /* secondary space extension value         */
-        u_int8_t  DS1DSRG1;           /* data set organisation byte 1            */
-        u_int8_t  DS1DSRG2;           /* data set organisation byte 2            */
-  	u_int8_t  DS1RECFM;           /* record format                           */
+	u_int8_t  DS1SMSFG;           /* system managed storage indicators       */
+	u_int8_t  DS1SCXTF;           /* sec. space extension flag byte          */
+	u_int16_t DS1SCXTV;           /* secondary space extension value         */
+	u_int8_t  DS1DSRG1;           /* data set organisation byte 1            */
+	u_int8_t  DS1DSRG2;           /* data set organisation byte 2            */
+	u_int8_t  DS1RECFM;           /* record format                           */
 	u_int8_t  DS1OPTCD;           /* option code                             */
 	u_int16_t DS1BLKL;            /* block length                            */
 	u_int16_t DS1LRECL;           /* record length                           */
 	u_int8_t  DS1KEYL;            /* key length                              */
 	u_int16_t DS1RKP;             /* relative key position                   */
 	u_int8_t  DS1DSIND;           /* data set indicators                     */
-        u_int8_t  DS1SCAL1;           /* secondary allocation flag byte          */
-  	char DS1SCAL3[3];         /* secondary allocation quantity           */
+	u_int8_t  DS1SCAL1;           /* secondary allocation flag byte          */
+	char DS1SCAL3[3];         /* secondary allocation quantity           */
 	ttr_t DS1LSTAR;           /* last used track and block on track      */
 	u_int16_t DS1TRBAL;           /* space remaining on last used track      */
-        u_int16_t res1;               /* reserved                                */
+	u_int16_t res1;               /* reserved                                */
 	extent_t DS1EXT1;         /* first extent description                */
 	extent_t DS1EXT2;         /* second extent description               */
 	extent_t DS1EXT3;         /* third extent description                */
@@ -175,9 +198,13 @@ typedef struct format4_label 
         char DS4F6PTR[5];         /* pointer to first format 6 DSCB          */
         extent_t DS4VTOCE;        /* VTOC extent description                 */
         char res2[10];            /* reserved                                */
-        u_int8_t DS4EFLVL;            /* extended free-space management level    */
+        u_int8_t DS4EFLVL;        /* extended free-space management level    */
         cchhb_t DS4EFPTR;         /* pointer to extended free-space info     */
-        char res3[9];             /* reserved                                */
+	char res3;		  /* reserved */
+	u_int32_t DS4DCYL;	  /* number of logical cyls */
+	char res4[2];		  /* reserved */
+        u_int8_t DS4DEVF2;        /* device flags */
+	char res5;		  /* reserved */
 } __attribute__ ((packed)) format4_label_t;
 
 
@@ -218,6 +245,16 @@ typedef struct format7_label 
 } __attribute__ ((packed)) format7_label_t;
 
 
+typedef struct format9_label
+{
+	u_int8_t  DS9KEYID;       /* key code for format 9 labels (0x09) */
+	u_int8_t  DS9SUBTY;       /* subtype (0x01) */
+	u_int8_t  DS9NUMF9;       /* number of F9 datasets  */
+	u_int8_t  res1[41];       /* reserved  */
+	u_int8_t  DS9FMTID;       /* format identifier  */
+	u_int8_t  res2[95];       /* reserved */
+} __attribute__ ((packed)) format9_label_t;
+
 char * vtoc_ebcdic_enc (char *source, char *target, int l);
 char * vtoc_ebcdic_dec (char *source, char *target, int l);
 void vtoc_set_extent (
@@ -228,13 +265,21 @@ void vtoc_set_extent (
         cchh_t * upper);
 void vtoc_set_cchh (
         cchh_t * addr,
-	u_int16_t cc,
+	u_int32_t cc,
 	u_int16_t hh);
+u_int32_t vtoc_get_cyl_from_cchh(cchh_t *addr);
+u_int16_t vtoc_get_head_from_cchh(cchh_t *addr);
 void vtoc_set_cchhb (
         cchhb_t * addr,
-        u_int16_t cc,
+        u_int32_t cc,
         u_int16_t hh,
         u_int8_t b);
+u_int32_t vtoc_get_cyl_from_cchhb(cchhb_t *addr);
+u_int16_t vtoc_get_head_from_cchhb(cchhb_t *addr);
+u_int64_t cchhb2blk(cchhb_t *p, struct hd_geometry *geo);
+u_int64_t cchh2blk (cchh_t *p, struct hd_geometry *geo);
+u_int32_t cchh2trk (cchh_t *p, struct hd_geometry *geo);
+
 void vtoc_set_date (
         labeldate_t * d,
         u_int8_t year,
@@ -287,7 +332,8 @@ void vtoc_write_label (
         format1_label_t *f1,
 	format4_label_t *f4,
 	format5_label_t *f5,
-	format7_label_t *f7);
+	format7_label_t *f7,
+	format9_label_t *f9);
 
 
 void vtoc_init_format1_label (
@@ -296,11 +342,11 @@ void vtoc_init_format1_label (
         extent_t *part_extent,
         format1_label_t *f1);
 
-
 void vtoc_init_format4_label (
         format4_label_t *f4lbl,
 	unsigned int usable_partitions,
-	unsigned int cylinders,
+	unsigned int compat_cylinders,
+	unsigned int real_cylinders,
 	unsigned int tracks,
 	unsigned int blocks,
 	unsigned int blksize,
@@ -311,7 +357,6 @@ void vtoc_update_format4_label (
 	cchhb_t *highest_f1,
 	u_int16_t unused_update);
 
-
 void vtoc_init_format5_label (
 	format5_label_t *f5);
 
@@ -323,7 +368,7 @@ void vtoc_update_format5_label_add (
 	u_int16_t a, 
 	u_int16_t b, 
 	u_int8_t c);
- 
+
 void vtoc_update_format5_label_del (
 	format5_label_t *f5,
 	int verbose,
@@ -333,7 +378,6 @@ void vtoc_update_format5_label_del (
 	u_int16_t b, 
 	u_int8_t c);
 
-
 void vtoc_init_format7_label (
 	format7_label_t *f7);
 
@@ -349,6 +393,18 @@ void vtoc_update_format7_label_del (
 	u_int32_t a, 
 	u_int32_t b);
 
+void vtoc_init_format8_label (
+        char *volid,
+        unsigned int blksize,
+        extent_t *part_extent,
+        format1_label_t *f1);
+
+void vtoc_update_format8_label (
+	cchhb_t *associated_f9,
+	format1_label_t *f8);
+
+void vtoc_init_format9_label (
+	format9_label_t *f9);
 
 void vtoc_set_freespace(
 	format4_label_t *f4,
@@ -358,8 +414,8 @@ void vtoc_set_freespace(
 	int verbose,
 	u_int32_t start,
 	u_int32_t stop,
-	int cyl,
-	int trk);
+	u_int32_t cyl,
+	u_int32_t trk);
 
 
 #endif /* VTOC_H */
Index: s390-tools-sles11/iucvterm/Makefile
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/Makefile
@@ -0,0 +1,28 @@
+#! /usr/bin/make -f
+
+include ../common.mak
+
+
+GETTEXT_TEXTDOMAIN = iucvterm
+export GETTEXT_TEXTDOMAIN
+
+
+SUBDIRS = src po doc bin etc test
+RECURSIVE_TARGETS = all-recursive install-recursive clean-recursive \
+                    check-recursive
+
+
+all: all-recursive
+check: check-recursive
+install: all install-recursive
+clean: clean-recursive
+
+
+$(RECURSIVE_TARGETS):
+	@target=`echo $@ |sed s/-recursive//`; \
+	for d in $(SUBDIRS); do \
+		(cd $$d && $(MAKE) $$target) \
+	done
+
+
+.PHONY: install clean
Index: s390-tools-sles11/iucvterm/bin/Makefile
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/bin/Makefile
@@ -0,0 +1,42 @@
+#! /usr/bin/make -f
+
+include ../../common.mak
+
+
+BIN_SCRIPTS = ts-shell
+SBIN_SCRIPTS = chiucvallow
+
+SCRIPTS = $(BIN_SCRIPTS) $(SBIN_SCRIPTS)
+
+
+all:
+check:
+install: $(SCRIPTS)
+	for prg in $(BIN_SCRIPTS); do \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(USRBINDIR) ; \
+	done
+	for prg in $(SBIN_SCRIPTS); do \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(USRSBINDIR) ; \
+	done
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -d $(INSTROOT)/var/log/ts-shell
+	ln -f -s chiucvallow $(USRSBINDIR)/lsiucvallow
+
+clean:
+	-rm -f *.o $(SCRIPTS)
+
+
+%: %.in
+	real_usrbin=`echo $(USRBINDIR) |sed 's#^$(INSTROOT)##'` ; \
+	my_sysconf=`echo $(SYSCONFDIR)/iucvterm |sed 's#^$(INSTROOT)##'` ; \
+	cat $< \
+	  |sed -e "s#@sysconf_path@#$$my_sysconf#g" \
+	       -e "s#@iucvconn_path@#$$real_usrbin#g" \
+	       -e 's#@S390_TOOLS_RELEASE@#$(S390_TOOLS_RELEASE)#g' \
+	> $@
+
+perl: ts-shell
+	perl -c $<
+
+scripts: $(SCRIPTS)
+
+.PHONY: install clean perl
Index: s390-tools-sles11/iucvterm/bin/chiucvallow.in
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/bin/chiucvallow.in
@@ -0,0 +1,273 @@
+#!/bin/sh
+#
+# z/VM IUCV HVC device driver -- Edit z/VM user ID filter
+#
+#
+# Copyright IBM Corp. 2009.
+# Author: Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+#
+PRG=`basename $0`
+
+# sysfs file that contains the z/VM user ID filter for the
+# z/VM IUCV HVC device driver
+sysfs_hvc_iucv_allow="/sys/module/kernel/parameters/hvc_iucv_allow"
+# older kernel versions do not have the "kernel" directory
+test -f $sysfs_hvc_iucv_allow || \
+	sysfs_hvc_iucv_allow="/sys/module/hvc_iucv/parameters/hvc_iucv_allow"
+
+
+show_help(){
+	cat <<"EoHelp"
+Usage:
+  chiucvallow [-h|--help] [-v|--version]
+
+  chiucvallow -l|--list
+  chiucvallow -c|--clear
+  chiucvallow -e|--edit  [<filter file>]
+  chiucvallow -s|--set    <filter file>
+  chiucvallow -V|--verify <filter file>
+
+
+Options:
+  -h|--help                     Print help information, then exit.
+  -v|--version                  Print version information, then exit.
+
+  -l|--list                     List current z/VM user ID filter.
+  -c|--clear                    Clear the z/VM user ID filter.
+  -e|--edit  [<filter file>]    Edit the z/VM user ID filter.
+  -s|--set    <filter file>     Set the z/VM user ID filter from a filter file.
+  -V|--verify <filter file>     Verify the z/VM user ID filter file.
+
+  The list, edit, set and clear options require root authority.
+EoHelp
+}
+
+show_version(){
+	cat <<EoVersion
+chiucvallow: List and change the z/VM user ID filter, version @S390_TOOLS_RELEASE@
+Copyright IBM Corp. 2009
+EoVersion
+}
+
+error(){
+	echo "$PRG: $1" >&2
+	exit ${2:-1}
+}
+
+hvciucv_available(){
+	test -r "$sysfs_hvc_iucv_allow" \
+		&& cat "$sysfs_hvc_iucv_allow" >/dev/null 2>&1
+	if test $? -gt 0; then
+		cat >&2 <<EoM
+$PRG: Failed to read z/VM user ID filter: $sysfs_hvc_iucv_allow
+Ensure that your Linux kernel supports the z/VM IUCV HVC device driver.
+EoM
+		exit 1
+	fi
+	return 0
+}
+
+
+#
+# List z/VM user ID filter information
+list_filter(){
+	cat $sysfs_hvc_iucv_allow |tr ',' '\n'
+}
+
+#
+# Verify z/VM user ID filter file
+verify_filter(){
+	local filename=$1
+	local failed=0
+	local count=0
+	local fsize=0
+
+	test -r "$filename" \
+		|| error "Failed to read z/VM user ID filter: $filename"
+
+	# check size... sysfs uses PAGE_SIZE and the filter should be below that
+	fsize=`grep -vE '^(\s*$|#)' $filename 2>/dev/null |wc -c`
+	if test "$fsize" -gt 4095; then
+		printf "$PRG: The z/VM user ID filter exceeds the maximum size (%d of %d bytes)\n" \
+			$fsize 4095 >&2
+		return -1
+	fi
+
+	while read userid; do
+		# skip empty lines and lines starting with '#'
+		echo "$userid" |grep -q -E '^(\s*$|#)' && continue
+
+		printf "Verify z/VM user ID: %-8s : " "$userid"
+		if echo -n "$userid" |grep -q -E -i '^[_$[:alnum:]]{1,8}$'; then
+			printf "OK\n"
+		else
+			printf "FAILED\n"
+			failed=$((failed + 1))
+		fi
+
+		count=$((count + 1))
+	done <$filename
+
+	test $count -gt 500 && \
+		error "The z/VM user ID filter exceeds the maximum of 500 user IDs"
+
+	printf "\n$PRG: Verification summary: verified=%d failed=%d size=%d bytes\n" \
+		$count $failed $fsize
+	return $failed
+}
+
+#
+# Edit the z/VM user ID filter
+edit_filter(){
+	local fromfile="$1"
+	local context=$2
+	local tmpfile=`mktemp /tmp/hvc_iucv_allow.XXXXXX`
+	local md5file=`mktemp /tmp/hvc_iucv_allow.md5.XXXXXX`
+
+	if test -w $tmpfile && test -w $md5file; then :; else
+		error "Creating temporary files failed"
+	fi
+
+	# save list in temp file
+	if test -r "$fromfile"; then cat $fromfile; else list_filter; fi > $tmpfile
+
+	# check whether to open editor
+	if test "x$context" != xnoeditor; then
+		md5sum $tmpfile > $md5file	# save checksum to track changes
+		${EDITOR:-vi} $tmpfile		# open editor
+		if md5sum --status -c $md5file; then
+			cat <<EoM
+$PRG: The filter is not updated because it has not been changed
+EoM
+			rm -f $tmpfile $md5file
+			exit 0
+		fi
+		rm -f $md5file
+	fi
+
+	# verify temp file content and, if successful, write back
+	if verify_filter $tmpfile >/dev/null; then :; else
+		cat >&2 <<EoM
+$PRG: Verifying the z/VM user ID filter failed.
+A backup copy has been saved as '$tmpfile'.
+Consider verifying the file using:
+    $0 --verify $tmpfile
+Correct the problem by editing the filter:
+    $0 --edit $tmpfile
+EoM
+	exit 2
+	fi
+
+	# Post-process and write z/VM user ID filter to sysfs file
+	#	1. skip empty and comment lines,
+	#	2. convert lower to upper case,
+	#	3. sort and remove duplicates,
+	#	4. replace '\n' with ',' and
+	#	5. and remove the last ','.
+	grep -Ev '^(\s*$|#)' $tmpfile \
+		|tr '[:lower:]' '[:upper:]' \
+		|sort -u \
+		|tr '\n' ',' \
+		|sed -e 's#,$##' > $sysfs_hvc_iucv_allow
+
+	if test x$? != x0; then
+		cat >&2 <<EoM
+$PRG: Writing the filter failed. Check for previous error messages.
+A backup copy has been saved as '$tmpfile'.
+Consider re-editing the file using \`$0 --edit $tmpfile'.
+EoM
+		exit 3
+	else
+		test "x$context" != xnoeditor && \
+			printf "$PRG: The filter has been updated successfully\n"
+	fi
+
+	# finally remove temporary files
+	rm -f $tmpfile $md5file 2>/dev/null
+	exit 0
+}
+
+#
+# Clear z/VM user ID filter
+clear_filter(){
+	echo > $sysfs_hvc_iucv_allow
+}
+
+#
+# Check whether we run as root, otherwise complain and exit
+for_root_only(){
+	local euid=`id -u 2>/dev/null`
+
+	test "x$euid" == x0 && return
+	error "You need root authority to use option '$1'"
+}
+
+lock_operation(){
+	( flock -nx 21 \
+		|| error "The filter is currently being changed. Try again later."
+		$@
+	) 21>/var/lock/hvc_iucv_allow
+}
+
+
+# Common options
+case $1 in
+	-h|--help)
+		show_help
+		exit 0
+	;;
+	-v|--version)
+		show_version
+		exit 0
+	;;
+esac
+
+# check the name under which we have been called
+case `basename $0` in
+	lsiucvallow) exec chiucvallow --list ;;
+esac
+
+# chiucvallow program options
+case $1 in
+	-l|--list)
+		for_root_only "$1"
+		hvciucv_available
+		list_filter
+	;;
+	-e|--edit)
+		for_root_only "$1"
+		hvciucv_available
+		lock_operation edit_filter "$2"
+	;;
+	-c|--clear)
+		for_root_only "$1"
+		hvciucv_available
+		lock_operation clear_filter
+	;;
+	-s|--set)
+		for_root_only "$1"
+		test -n "$2" \
+			|| error "This option requires a file as argument"
+		test -r "$2" \
+			|| error "The specified file must be readable"
+		hvciucv_available
+		lock_operation edit_filter "$2" noeditor
+	;;
+	-V|--verify)
+		test -n "$2" \
+			|| error "This option requires a file as argument"
+		verify_filter "$2"
+		exit $?
+	;;
+	'')
+		echo "$PRG: One or more arguments are missing" >&2
+		echo "Try '$0 --help' for more information." >&2
+		exit 201
+	;;
+	*)
+		echo "$PRG: Invalid option -- '$1'" >&2
+		echo "Try '$0 --help' for more information." >&2
+		exit 201
+	;;
+esac
+exit 0
